diff --git a/src/gui/kernel/qguiapplication.cpp b/src/gui/kernel/qguiapplication.cpp
index 96bea94..fc57685 100644
--- a/src/gui/kernel/qguiapplication.cpp
+++ b/src/gui/kernel/qguiapplication.cpp
@@ -1979,10 +1979,12 @@ void QGuiApplicationPrivate::processWindowStateChangedEvent(QWindowSystemInterfa
 
 void QGuiApplicationPrivate::processWindowScreenChangedEvent(QWindowSystemInterfacePrivate::WindowScreenChangedEvent *wse)
 {
+    qDebug() << __FUNCTION__ << wse->window.data() << wse->screen.data();
     if (QWindow *window  = wse->window.data()) {
-        if (QScreen *screen = wse->screen.data())
+        if (QScreen *screen = wse->screen.data()) {
+            qDebug() << __FUNCTION__ << window << screen;
             window->d_func()->setTopLevelScreen(screen, false /* recreate */);
-        else // Fall back to default behavior, and try to find some appropriate screen
+        } else // Fall back to default behavior, and try to find some appropriate screen
             window->setScreen(0);
     }
 }
diff --git a/src/gui/kernel/qscreen.cpp b/src/gui/kernel/qscreen.cpp
index 90f48d4..03b0807 100644
--- a/src/gui/kernel/qscreen.cpp
+++ b/src/gui/kernel/qscreen.cpp
@@ -46,7 +46,7 @@
 #include <qpa/qplatformscreen.h>
 
 #include <QtCore/private/qobject_p.h>
-
+#include <QtCore/QDebug>
 QT_BEGIN_NAMESPACE
 
 /*!
@@ -80,6 +80,7 @@ QScreen::QScreen(QPlatformScreen *screen)
  */
 QScreen::~QScreen()
 {
+    qDebug() << __FUNCTION__ << name();
     if (qApp)
         Q_EMIT qApp->screenRemoved(this);
 }
diff --git a/src/gui/kernel/qwindow.cpp b/src/gui/kernel/qwindow.cpp
index 327544c..02df5fa 100644
--- a/src/gui/kernel/qwindow.cpp
+++ b/src/gui/kernel/qwindow.cpp
@@ -378,6 +378,7 @@ void QWindowPrivate::emitScreenChangedRecursion(QScreen *newScreen)
 
 void QWindowPrivate::setTopLevelScreen(QScreen *newScreen, bool recreate)
 {
+    qDebug() << __FUNCTION__ << q_func() << newScreen << newScreen->name() << recreate;
     Q_Q(QWindow);
     if (parentWindow) {
         qWarning() << this << Q_FUNC_INFO << '(' << newScreen << "): Attempt to set a screen on a child window.";
@@ -387,6 +388,7 @@ void QWindowPrivate::setTopLevelScreen(QScreen *newScreen, bool recreate)
         const bool shouldRecreate = recreate && windowRecreationRequired(newScreen);
         if (shouldRecreate)
             q->destroy();
+        qDebug() << __FUNCTION__ << q << '2' << "shouldRecreate" << shouldRecreate;
         connectToScreen(newScreen);
         if (newScreen && shouldRecreate)
             q->create();
@@ -1675,6 +1677,9 @@ QScreen *QWindow::screen() const
 */
 void QWindow::setScreen(QScreen *newScreen)
 {
+    qDebug() << __FUNCTION__ << this << "newScreen" << newScreen;
+    if(newScreen)
+       qDebug() << newScreen->name();
     Q_D(QWindow);
     if (!newScreen)
         newScreen = QGuiApplication::primaryScreen();
@@ -1684,6 +1689,7 @@ void QWindow::setScreen(QScreen *newScreen)
 void QWindow::screenDestroyed(QObject *object)
 {
     Q_D(QWindow);
+    qDebug() << __FUNCTION__ << this << object;
     if (d->parentWindow)
         return;
     if (object == static_cast<QObject *>(d->topLevelScreen)) {
diff --git a/src/plugins/platforms/windows/qwindowswindow.cpp b/src/plugins/platforms/windows/qwindowswindow.cpp
index 51497b3..18428f5 100644
--- a/src/plugins/platforms/windows/qwindowswindow.cpp
+++ b/src/plugins/platforms/windows/qwindowswindow.cpp
@@ -604,6 +604,7 @@ QWindowsWindowData
     qCDebug(lcQpaWindows).nospace()
         << "CreateWindowEx: returns " << w << ' ' << result.hwnd << " obtained geometry: "
         << context->obtainedGeometry << context->margins;
+    qDebug() << __FUNCTION__  << w << debugWinStyle(style) << debugWinExStyle(exStyle);
 
     if (!result.hwnd) {
         qErrnoWarning("%s: CreateWindowEx failed", __FUNCTION__);
@@ -1393,13 +1394,15 @@ void QWindowsWindow::handleGeometryChange()
     }
     if (previousGeometry.topLeft() != m_data.geometry.topLeft()) {
         QPlatformScreen *newScreen = screenForGeometry(m_data.geometry);
-        if (newScreen != screen())
+        if (newScreen != screen()) {
+            qDebug() << __FUNCTION__ << window() << "ScreenChanged in move";
             QWindowSystemInterface::handleWindowScreenChanged(window(), newScreen->screen());
+        }
     }
     if (testFlag(SynchronousGeometryChangeEvent))
         QWindowSystemInterface::flushWindowSystemEvents();
 
-    qCDebug(lcQpaEvents) << __FUNCTION__ << this << window() << m_data.geometry;
+    qDebug() << __FUNCTION__ << this << window() << m_data.geometry;
 }
 
 void QWindowsWindow::setGeometry_sys(const QRect &rect) const